//
// Created by robtor on 04.01.23.
//

#include "Menu_Entry_Type_Numeric.h"

namespace floatpump {
    namespace menu {

        Menu_Entry_Type_Numeric::Menu_Entry_Type_Numeric(uint16_t mValue) {
            m_value = new uint16_t(mValue);
        }

        std::string Menu_Entry_Type_Numeric::toString() {
            if (m_entered) {
                return fmt::format("> {{:5}", *m_value);
            } else {
                return fmt::format("  {{:5}", *m_value);            }
        }

        void Menu_Entry_Type_Numeric::u_press() {
            m_entered = !m_entered;
        }

        void Menu_Entry_Type_Numeric::u_increase(uint16_t steps) {
            (*m_value)++;
        }

        void Menu_Entry_Type_Numeric::u_decrease(uint16_t steps) {
            (*m_value)--;
        }

        bool Menu_Entry_Type_Numeric::isEntered() {
            return m_entered;
        }

        void Menu_Entry_Type_Numeric::linkConfig(uint16_t *link) {
            m_value = link;
        }
    } // floatpump
} // menu